vokeys.ui = vokeys.ui or {}

local help_text = 'Keys v'..vokeys.version..'\n'..
"\t Commands with (s) can take more than one at a time.\t* are retricted to admins.  They simply will do nothing if your character is not in the admin list..\n"..
"/keys -addown username\t\t\t\t\t - Issues Owner keys to username.  * Also adds them to the Owner key list.\n"..
"/keys -adduser username(s)\t\t\t\t\t - Issues user keys to username.  Also adds them to the user key list.\n"..
"/keys -cleankeys\t\t\t\t\t\t\t - Scans your owner keys that are inactive and revokes the user keys for everyone.\n"..
"/keys -delete keynum(s)\t\t\t\t\t - Deletes the keynum(s).\n"..
"/keys -guild\t\t\t\t\t\t\t - Issues keys to all on-line guild members and adds them to the user key list.\n"..
"/keys -list\t\t\t\t\t\t\t\t - Lists all keys and their numbers.\n"..
"/keys -listkey number\t\t\t\t\t\t - Lists all players that have the key.\n"..
"/keys -listown\t\t\t\t\t\t\t - Lists all your owner keys.\n"..
"/keys -listuser\t\t\t\t\t\t\t - Lists all your user keys.\n"..
"/keys -purge\t\t\t\t\t\t\t - Purge old user keys that are inactive.\n"..
"/keys -remove username\t\t\t\t\t - Removes a user from the user and owner key lists.  Does not revoke keys.\n"..
"/keys -revoke username\t\t\t\t\t - Revokes all user keys from username.  Removes user from both user key list, and Owner key list.\n"..
"/keys -revokeall keynum\t\t\t\t\t - Revokes all users from keynum.  Good for cleaning a key.  Does not remove them from the key lists.\n"..
"/keys -saved\t\t\t\t\t\t\t - Issues keys to all in the saved lists.  User keys to user list, and owner keys to Owner list.\n"..
"/keys -show\t\t\t\t\t\t\t - Show saved list of users.  Both users and owners.\n"..
"/keys -ver\t\t\t\t\t\t\t\t - Displays the current version.\n\n"..
"/keystat\t\t\t\t\t\t\t\t - Show keys we have now.  Short version is /ks\n"

	
	
function vokeys.ui:ShowHelp()
	StationHelpDialog:Open(help_text)
end

function vokeys.ui:ShowOutput(data)
	StationHelpDialog:Open(data)
end

	local button_help = iup.stationbutton{title="Help", hotkey=iup.K_h, action=vokeys.ui.ShowHelp}
	local button_ok = iup.stationbutton{title="OK"}
	
	local frame = iup.vbox{
		iup.hbox{iup.fill{}, iup.label{title="Keys v"..vokeys.version,font=Font.H3}, iup.fill{}},
		iup.fill{size=10},
		iup.hbox{iup.fill{size=12}, options_box, iup.fill{}, gap=8},
		iup.fill{size=8},
		iup.hbox{button_help, iup.fill{}, button_ok, gap=8},
		alignment="ACENTER",
	}
	
	-- Create Dialog --
	
	vokeys.ui.dialog = iup.dialog{
		iup.vbox{
			iup.fill{},
			iup.hbox{
				iup.fill{},
				iup.stationhighopacityframe{
					iup.stationhighopacityframebg{
						frame,
						expand="NO",
						gap=8,
					},
				},
				iup.fill{},
			},
			iup.fill{},
		},
		BGCOLOR = "0 0 0 160 *",
		FULLSCREEN="YES",
		RESIZE="NO",
		BORDER="NO",
		MENUBOX="YES",
		TOPMOST="YES",
		DEFAULTESC=button_ok,
		DEFAULTENTER=button_ok,
	}
	vokeys.ui.dialog:map()
	
	function vokeys.ui:Show()
		ui.Update(self) --reset control values in case of changed by console
		ShowDialog(ui.dialog,iup.CENTER,iup.CENTER)
		iup.Refresh(ui.dialog)
	end
	
	--capture state of controls and save to config
	function vokeys.ui:Hide()
		HideDialog(ui.dialog)
	end
	
	function button_ok.action() vokeys.ui.Hide(button_ok) end
	return vokeys.ui
		
