vokeys.settings = vokeys.settings or {}
vokeys.settings.showinactive = vokeys.settings.showinactive or 0
vokeys.vars = vokeys.vars or {}
vokeys.vars.showinactive = vokeys.vars.showinactive or 0

--vokeys.ui.settings.showinactive = iup.stationtoggle{title="Show Inactive Keys", value=vokeys.var.showinactive}



function vokeys.ui.close_dialog()
	vokeys.ui.dlg:hide()
end

function vokeys.ui.create_dialog()


local size_matrix = vokeys.ui.count_key_matrix()
	-- Keychain tab
	local key_table = iup.matrix {numcol=5, numlin=size_matrix or 10, markmode="LIN", expand="YES", bgcolor="0 0 0 80 *"}
	--local key_table = iup.matrix {numcol=5, numlin=18, markmode="LIN", expand="YES", bgcolor="0 0 0 80 *"}
	--local key_table = iup.matrix {numcol=5, markmode="LIN", expand="YES", bgcolor="0 0 0 80 *"}
	vokeys.ui.fill_key_matrix(key_table)
	local keychain_tab = iup.hbox {key_table, iup.fill{}}
	keychain_tab.tabtitle = "My KeyChain"

	-- Users key tab
	local users_table = iup.matrix {numcol=1, numlin=#vokeys.Users, markmode="LIN", expand="YES", bgcolor="0 0 0 80 *"}
	users_table:setcell(0,1,"Player Name")
	vokeys.ui.fill_user_key_matrix(users_table)
	local users_tab = iup.vbox {users_table, iup.fill{size=10}}
	users_tab.tabtitle = "User Keys List"

	-- Owner key tab
	local owners_table = iup.matrix {numcol=1, numlin=#vokeys.Owners, markmode="LIN", expand="YES", bgcolor="0 0 0 80 *"}
	owners_table:setcell(0,1,"Player Name")
	vokeys.ui.fill_owner_key_matrix(owners_table)
	local owners_tab = iup.vbox {owners_table, iup.fill{size=10}}
	owners_tab.tabtitle = "Owner Keys List"

	-- bottom close button
	local close_button = iup.button{title="Close", size=100}
	function close_button:action ()
		vokeys.ui.close_dialog()
	end

	local saved_button = iup.button{title="Saved", size=100}
	function saved_button:action ()
		vokeys.Saved()
	end
	
	local guild_button = iup.button{title="Guild", size=100}
	function guild_button:action ()
		vokeys.Guild()
	end
	
	
	
	
	
	--local active_keys_items = iup.stationtoggle{ value=vokeys.settings.showinactive, title="Show Inactive Keys"}
	--local active_keys_items = iup.stationtoggle{title="Show Inactive Keys"}
	--vokeys.ui.settings.showinactive
	--iup.stationtoggle{title="Sector Chat", action=function() relay.toggle("sector") end},
	vokeys.ui.showinactive = iup.stationtoggle{title="Show Inactive Keys", value=vokeys.vars.showinactive}

	function vokeys.ui.showinactive.action(_, state)
		--key_table = iup.matrix {numcol=5, numlin=size_matrix or 10, markmode="LIN", expand="YES", bgcolor="0 0 0 80 *"} 
		vokeys.vars.showinactive = state 
		print("set state to "..vokeys.vars.showinactive)
		--size_matrix = vokeys.ui.count_key_matrix()
		--key_table.numlin = size_matrix
		--vokeys.ui.fill_key_matrix(key_table)
		--vokeys.ui.dlg:hide()
		--vokeys.ui.dlg:redraw()
		--vokeys.ui.close_dialog()
	end 

	





	
	local bottom_button_box = iup.hbox {iup.fill{}, vokeys.ui.showinactive, guild_button, saved_button, close_button, gap=5}

	-- dialog
	
	local tabs = iup.pda_root_tabs{keychain_tab, users_tab, owners_tab }
	
	local dialog_vbox = iup.vbox {
		tabs,
		iup.fill{size="%2"},
		bottom_button_box,
		expand="YES",
	}
	
	vokeys.ui.dlg = iup.dialog{
    iup.vbox{
			iup.fill{size="%10"},
        iup.hbox{
					iup.fill{size="%15"},
					iup.pdarootframe{
						dialog_vbox
					},
					iup.fill{size="%15"},
       },
        iup.fill{size="%10"},
			},
		defaultesc=vokeys.ui.close_dialog,		
    bgcolor="0 0 0 144 *",
    fullscreen="YES",
    border="NO",
    resize="NO",
    maxbox="NO",
    minbox="NO",
    menubox="NO",
    topmost="YES",
	}
	vokeys.ui.dlg:map()
	vokeys.ui.dlg:show()

end

-- Build the matrix for our key list.  
function vokeys.ui.fill_key_matrix(table)
	--table = iup.matrix {numcol=5, numlin=15, markmode="LIN", expand="YES", bgcolor="0 0 0 80 *"}
	table:setcell(0,1,"KeyID")
	table:setcell(0,2,"Name")
	table:setcell(0,3,"Access To")
	table:setcell(0,4,"Capship")

	local row = 1
	local color
	for i = 1, #vokeys.KeyTable, 1 do 		
		color = vokeys.colors.WHITE
		if (vokeys.KeyTable[i].ACTIVE or vokeys.settings.showinactive == 1) then 



			if not vokeys.KeyTable[i].OWN and vokeys.KeyTable[i].ACTIVE	then 
				color = vokeys.colors.GOLD
			elseif not vokeys.KeyTable[i].ACTIVE then
				color = vokeys.colors.RED
			end
			table:setcell(row, 1, color..vokeys.KeyTable[i].ID)
			table:setcell(row, 2, color..vokeys.KeyTable[i].DESC)
			local temp = ""
			if not (vokeys.IsCapshipKey(vokeys.KeyTable[i])) and (vokeys.KeyTable[i].ACCESS[1]) then
				for j = 1, #vokeys.KeyTable[i].ACCESS,1 do
				temp = temp..vokeys.KeyTable[i].ACCESS[j][1].name.."  "
				end
			end
			table:setcell(row, 3, color..temp)
			table:setcell(row,4,"")
			if vokeys.IsCapshipKey(vokeys.KeyTable[i]) then 
				table:setcell(row,4,vokeys.colors.YELLOW..vokeys.KeyTable[i].ACCESS[1][1].name)
			end
		--if vokeys.debug then print("Data for row: "..row.."Data:"..vokeys.KeyTable[i].ID) end
		row = row + 1
		end
		
		
		
		
	end
	if vokeys.debug then print("Number of returned rows: "..row-1) end
	table["numlin"] = row-1
	--return row-1
	--LisaJunk = table
	--table:SetAttribute("numlin", row-1)
end
-- Build the matrix for our key list.  

function vokeys.ui.count_key_matrix()
	local row = 1
	
	for i = 1, #vokeys.KeyTable, 1 do 		
		--color = vokeys.colors.WHITE
		if (vokeys.KeyTable[i].ACTIVE or vokeys.settings.showinactive == 1) then 
			row = row + 1
		end
	end
	if vokeys.debug then print("Number of returned rows3: "..row-1) end
	return row-1
end

-- Build the matrix for our user key list.  
function vokeys.ui.fill_user_key_matrix(table)
	local row = 1
	local color
	for i = 1, #vokeys.Users, 1 do 		
		color = vokeys.colors.WHITE
		table:setcell(row, 1, color..vokeys.Users[i])
		row = row + 1
	end
end

-- Build the matrix for our Owner key list.  
function vokeys.ui.fill_owner_key_matrix(table)
	local row = 1
	local color
	for i = 1, #vokeys.Owners, 1 do 		
		color = vokeys.colors.WHITE
		table:setcell(row, 1, color..vokeys.Owners[i])
		row = row + 1
	end
end
